<?php
// "Les derniers articles" "Les dernières pages" Jean-Denis https://adhoc.71site.fr 2023 dernière révision mars 2024
// basé sur le script pages/index.php (CMS adHoc https://www.cmsadhoc.net/ )
// modifié et adapté pour s'intégrer dans une boîte adHoc moyennant un fork du fichier modules/boxes/lateral.inc
// PARTIE Fonctions, Adaptations, Affichage (l'autre partie se nomme data/boxes/special/boxe_XX.php)
// Il n'est pas nécessaire de modifier cette partie
// Licence: GNU-GPL V3

// Fonctions
$sep = "-";
function der_nettoyage($chaine) {
	$cherche = array(
		"À", "Á", "Â", "Ã", "Ä", "Å", "Æ", "Ç", "È", "É", "Ê", "Ë", "Ì", "Í", "Î", "Ï",
		"Ð", "Ñ", "Ò", "Ó", "Ô", "Õ", "Ö", "Ø", "Ù", "Ú", "Û", "Ü", "Œ", " ", "'", ".",
		"à", "á", "â", "ã", "ä", "å", "æ", "ç", "è", "é", "ê", "ë", "ì", "í", "î", "ï",
		"ð", "ñ", "ò", "ó", "ô", "õ", "ö", "ø", "ù", "ú", "û", "ü", "ý", "œ", "&"
	);
	$remplace = array(
		"a", "a", "a", "a", "a", "a", "ae", "c", "e", "e", "e", "e", "i", "i", "i", "i",
		"o", "n", "o", "o", "o", "o", "o", "o", "u", "u", "u", "u", "oe", "-", "-", "_",
		"a", "a", "a", "a", "a", "a", "ae", "c", "e", "e", "e", "e", "i", "i", "i", "i",
		"o", "n", "o", "o", "o", "o", "o", "o", "u", "u", "u", "u", "y", "oe", "-and-"
	);
	$chaine = strtolower(str_replace($cherche, $remplace, strip_tags($chaine)));
	$chaine = preg_replace('/[^[:alnum:]|_|-]+/','',$chaine);
	return mb_convert_encoding(preg_replace('/-+/', '-', $chaine),'ASCII');
}

function der_datepourcomparaison($date) {
	$nouvdate = substr($date, 0, -8).$sep.substr($date, 4, -6).$sep.substr($date, 6, -4);
	return $nouvdate;
}

function der_calculintervaledate($datejour, $datecible) {
	$dj = date_create(der_datepourcomparaison($datejour));
	$dc = date_create(der_datepourcomparaison($datecible));
	$intervale = date_diff($dj, $dc);
	return $intervale->format('%a');
}

// Elaboration des variables array $derdbwork[] contenant tous les éléments d'une page :
// "numéro" "nom de la page "nom de sa catégorie" "date création" "date modification" "active ou inactive" "durée affichage newup"
$idlg = USER_LANG;
$cpmenu = true;

if (defined('PGBX_INC')) { // test pour affichage page index ou default

	for ($i=0; $i < count(glob(PGBX_INC.'*.inc')); $i++) {
		if (file_exists(PATH."modules/pages/mod_lat_pages_".$i.".inc")) {
			$derpboxes[$i] = PGBX_INC.'mod_lat_pages_'.$i.'.inc';
			include($derpboxes[$i]); // fichiers menus
			$derpbxrights[$idpg_menu] = $pm_rights; // droits des menus
		}
	}

} else { // alternative test pour affichage page index ou default

	for ($i=0; $i < count(glob('modules/pages/*.inc')); $i++) {
		if (file_exists(PATH."modules/pages/mod_lat_pages_".$i.".inc")) {
			$derpboxes[$i] = 'modules/pages/mod_lat_pages_'.$i.'.inc';
			include($derpboxes[$i]); // fichiers menus
			$derpbxrights[$idpg_menu] = $pm_rights; // droits des menus
		}
	}

}

$cpmenu = false;

if (defined('PGBX_INC')) { // test pour affichage page index ou default

	$dercountctlist = count(file(PGBX_DAT.'list_'.$idlg.'.dbt')); // nombre de catégories
	$dercontenu = fopen( PGBX_DAT.'list_'.$idlg.'.dbt', 'r' );

} else { // alternative test pour affichage page index ou default

	$dercountctlist = count(file('data/pages/list_'.$idlg.'.dbt')); // nombre de catégories
	$dercontenu = fopen( 'data/pages/list_'.$idlg.'.dbt', 'r' );

}

	for ($i=0; $i < $dercountctlist ; $i++) {
	$lignecat = fgets($dercontenu);
	$elem = explode(";", $lignecat);
		for ($j=0; $j < 7;$j++) {
			$derctlist [$i][$j] = $elem[$j]; // création variables [catégorie][élément]
		}
	}
	fclose($dercontenu);

for ($i=0; $i < $dercountctlist; $i++ ) { // boucle pour chaque catégorie
	if (in_array($derctlist[$i][0], $catinterdite)) {continue;} // test de l'Id de la catégorie (saute l'hypothèse si catégorie interdite)
	if (USER_LEVEL >= $derpbxrights[$derctlist[$i][1]]) { // droits d'affichage
		$derdbwork[] = array("*", $derctlist[$i][3]);

		if (defined('PGBX_IDX')) { // test pour affichage page index ou default

		$dercountpglist = count(file(PGBX_IDX.$derctlist[$i][0].$idlg.'.dbt')); // nombre de pages dans catégorie
		$dercontenucat = fopen( PGBX_IDX.$derctlist[$i][0].$idlg.'.dbt', 'r' );

		} else { // alternative test pour affichage page index ou default

		$dercountpglist = count(file('data/pages/pgidx_'.$derctlist[$i][0].$idlg.'.dbt')); // nombre de pages dans catégorie
		$dercontenucat = fopen( 'data/pages/pgidx_'.$derctlist[$i][0].$idlg.'.dbt', 'r' );

		}

		for ($k=0; $k < $dercountpglist ; $k++) {
			$lignepage = fgets($dercontenucat);
			$elemt = explode(";", $lignepage);
				for ($j=0; $j < 6;$j++) {
					$derpglist [$k][$j] = $elemt[$j]; // création variables [page][élément]
				}
			//  contenu $derdbwork[] : "numéro" "nom de la page "nom de sa catégorie" "date création" "date modification" "active ou inactive" "durée affichage newup"
			$derdbwork[] = array($derpglist[$k][0], $derpglist[$k][1], $derctlist[$i][3], $derpglist[$k][3], $derpglist[$k][4], $derpglist[$k][2], $derpglist[$k][5]);
		} 
		fclose($dercontenucat);
		//$pgtotitems += $dercountpglist; 
	}
}

$count = count($derdbwork); // nombre d'articles/pages

// si affichage info nouveauté ou maj prévu : choix texte ou image
if($derinfonewup == 'oui') {
	if ($dernewup == "texte") {
		$pg_img_upd = '<span class="label-upd" '.$derstylesupupd.'>'.$msg_pub['updated'].'</span>';
		$pg_img_new = '<span class="label-new" '.$derstylesupnew.'>'.$msg_pub['new'].'</span>';
	} else {
		$pg_img_upd = '<img class="img-upd" '.$derstylesupupd.'src="'.PATH_LNK.'modules/pages/img/'.$derimageUpdate.'" alt="up" title="Updated"/>';
		$pg_img_new = '<img class="img-new" '.$derstylesupnew.'src="'.PATH_LNK.'modules/pages/img/'.$derimageNew.'" alt="new" title="New"/>';
	}
}

// Affichage
echo "<!-- début affichage derniers -->\n";
if ($derafftitre == 'oui') { // affichage ou non du titre
	if ($coum == 3) {
		echo "<h3 ".$derstylesup1.">".$dermessage3."</h3>\n";
	}
	else {
		echo "<h3 ".$derstylesup1.">".$dermessage4."</h3>\n";
	} 
} else { echo "<br />\n"; }

$pageschoisies = array(); // initialisation variable tableau avant boucle $i
for ($k=0; $k < $nbchoix; $k++) {
	$pageschoisies[$k] = '';
}

for ($i=0; $i < $nbchoix; $i++) {
	$datetop = ''; // initialisations variables avant boucle $j
	$top = 0;

	for ($j=0; $j < $count; $j++ ) {
		if ($derdbwork[$j][0] == "*" || in_array($derdbwork[$j][0], $derpagesexclues) || in_array($derdbwork[$j][0], $pageschoisies) || $derdbwork[$j][5] == 'i') {
			continue ; // saute l'affichage de ces hypothèses
			}
	if ($derdbwork[$j][4] > $datetop) { $datetop = $derdbwork[$j][4]; $top = $j; $pageschoisies[$i] = $derdbwork[$j][0];}
	}

if ($deraffcat == 'oui') { // affichage ou non du nom de catégorie + der_nettoyage guillemets
$taillecat = strlen($derdbwork[$top][2]);
if (substr($derdbwork[$top][2], 0, -($taillecat-1)) == '"' && substr($derdbwork[$top][2], -1, 1) == '"') 
	{$nomcat = substr($derdbwork[$top][2], 1, -1);}
else {$nomcat = $derdbwork[$top][2];}

echo "<p ".$derstylesup2.">".$nomcat."</p>\n";
}

$tailleart = strlen($derdbwork[$top][1]); // affichage nom article + der_nettoyage guillemets
if (substr($derdbwork[$top][1], 0, -($tailleart-1)) == '"' && substr($derdbwork[$top][1], -1, 1) == '"') 
	{$nomart = substr($derdbwork[$top][1], 1, -1);}
else {$nomart = $derdbwork[$top][1];}

if (defined('PGBX_IDX')) { // test pour affichage page index ou default
echo "<p ".$derstylesup3."><a href=\"".$derdbwork[$top][0].der_nettoyage($sep.$derdbwork[$top][2].$sep.$derdbwork[$top][1].$sep).$idlg.".php"."\" ".$derciblelien." >".$nomart."</a>";
} else { // alternative test pour affichage page index ou default
echo "<p ".$derstylesup3."><a href=\"pages/".$derdbwork[$top][0].der_nettoyage($sep.$derdbwork[$top][2].$sep.$derdbwork[$top][1].$sep).$idlg.".php"."\" ".$derciblelien." >".$nomart."</a>";
}

// si affichage info nouveauté ou maj prévu
if($derinfonewup == 'oui') {
	$newup = '';
	if (der_calculintervaledate(date("YmdHi"), $derdbwork[$top][3]) - $derdbwork[$top][6] <= 0 && der_datepourcomparaison($derdbwork[$top][3]) == der_datepourcomparaison($derdbwork[$top][4])) { // comparaison date création
		$newup = $pg_img_new;
	}
	elseif (der_calculintervaledate(date("YmdHi"), $derdbwork[$top][4]) - $derdbwork[$top][6] <= 0) { // comparaison date modification
		$newup = $pg_img_upd;
	}
	echo $newup;
}

echo "</p>\n";
}
echo "<!-- fin affichage derniers -->\n";
?>


